<?php
/*ʹPHP ̨ MVB2000 WEBCTIӿ*/
Class MVB2000_WEBCTI {
	var $xml_result =array();
	var $xml_elem = null;

	function xml_startElement( $parser, $name, $attrs ) 
	{
	  global $g_rows, $g_elem;	 
	  if ($name == 'ROW'){
	  	$this->xml_result[]=array();  	
	  }
	  $this->xml_elem = $name;
	}
	function xml_endElement( $parser, $name ) 
	{
	   $this->xml_elem = null;
	}
	function xml_textData( $parser, $text )
	{
	 
	  $this->xml_elem=trim($this->xml_elem);
	  if ( $this->xml_elem != 'ROOT' && $this->xml_elem != 'ROW' && strlen($this->xml_elem)>0 ){
	  	$i =count($this->xml_result);
	  	if( $i > 0 )$i=$i-1;
	  	$this->xml_result[$i][$this->xml_elem] = $text;
	  }
	}
	function xml_parser($url){
		$this->$xml_result=array();
		$this->$xml_elem = null;
		$parser = xml_parser_create();  
		xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
		xml_set_element_handler($parser, array(&$this, 'xml_startElement'),array(&$this, 'xml_endElement'));
		xml_set_character_data_handler($parser, array(&$this, 'xml_textData'));
		$f = fopen( $url, 'rb' ); 
		if ($f===false){
				$this->xml_result[0]['xmlerrcode']='1';
				$this->xml_result[0]['xmlerrmsg']='WEBCTIӿʧ';
			  return $this->xml_result;
		}
		while( $data = fread($f,4096))
		{
			if(xml_parse( $parser, $data )===false){			 
				$errcode=xml_get_error_code ($parser);
				$errmsg=xml_error_string ($errcode);
				$this->xml_result[0]['xmlerrcode']='2';
				$this->xml_result[0]['xmlerrmsg']="($errcode)".$errmsg;
				return $this->xml_result;
			}
		}
		xml_parser_free( $parser );
		return $this->xml_result;
	}
	function xml_webkey($webkey) 
	{
	   return md5($webkey.date('Y-m-d'));
	}
}

$WEBCTI=new MVB2000_WEBCTI();
$webkey='0866089e569bbd3d';
$webhost='http://192.168.0.218';
$apiname="getqueuemember.php";
$queue='7910';

$newkey=$WEBCTI->xml_webkey($webkey);
$url="{$webhost}/webservice/{$apiname}?webkey={$newkey}&queue={$queue}";
$res=$WEBCTI->xml_parser($url);
echo ":<br \>";
print_r($res);
?>